Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3479)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3525)
@@ -27,4 +27,8 @@
 ! -----------------
 ! $Id$
+! Clean up, renaming from "biom" to "bio", summary of thermal index calculation
+! into one module (dom_dwd_user)
+! 
+! 3479 2018-11-01 16:00:30Z gronemeier
 ! - reworked check for output quantities
 ! - assign new palm-error numbers
@@ -72,14 +76,5 @@
 
     USE basic_constants_and_equations_mod,                                     &
-       ONLY:  degc_to_k, magnus, sigma_sb
-
-    USE biometeorology_ipt_mod
-
-    USE biometeorology_pet_mod
-
-    USE biometeorology_pt_mod,                                                 &
-       ONLY: calculate_pt_static
-
-    USE biometeorology_utci_mod
+       ONLY:  c_p, degc_to_k, l_v, magnus, sigma_sb
 
     USE control_parameters,                                                    &
@@ -92,5 +87,6 @@
 
     USE indices,                                                               &
-       ONLY:  nxl, nxr, nys, nyn, nzb, nzt, nys, nyn, nxl, nxr
+       ONLY:  nxl, nxr, nys, nyn, nzb, nzt, nys, nyn, nxl, nxr, nxlg, nxrg,    &
+              nysg, nyng
 
     USE kinds  !< Set precision of INTEGER and REAL arrays according to PALM
@@ -112,47 +108,48 @@
 !-- Declare all global variables within the module (alphabetical order)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tmrt_grid  !< tmrt results (Â°C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pt_grid    !< PT results   (Â°C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  perct      !< PT results   (Â°C)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci_grid  !< UTCI results (Â°C)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet_grid   !< PET results  (Â°C)
-!-- Grids for averaged thermal indices       
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pt_av_grid    !< PT results (aver. input)   (Â°C)
+!-- Grids for averaged thermal indices
+    REAL(wp), DIMENSION(:), ALLOCATABLE   ::  mrt_av_grid   !< time average mean
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  perct_av      !< PT results (aver. input)   (Â°C)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci_av_grid  !< UTCI results (aver. input) (Â°C)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet_av_grid   !< PET results (aver. input)  (Â°C)
-!-- Grids for radiation_model
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  biom_mrt     !< biometeorology mean radiant temperature for each MRT box
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  biom_mrt_av  !< time average mean
-
-    INTEGER( iwp ) ::  biom_cell_level     !< cell level biom calculates for
-    REAL ( wp )    ::  biom_output_height  !< height output is calculated in m
-    REAL ( wp )    ::  time_biom_results   !< the time, the last set of biom results have been calculated for
+
+
+    INTEGER( iwp ) ::  bio_cell_level     !< cell level biom calculates for
+    REAL ( wp )    ::  bio_output_height  !< height output is calculated in m
+    REAL ( wp )    ::  time_bio_results   !< the time, the last set of biom results have been calculated for
     REAL ( wp ), PARAMETER ::  human_absorb = 0.7_wp  !< SW absorbtivity of a human body (Fanger 1972)
     REAL ( wp ), PARAMETER ::  human_emiss = 0.97_wp  !< LW emissivity of a human body after (Fanger 1972)
 !--
 
-    LOGICAL ::  aver_pt  = .FALSE.  !< switch: do pt averaging in this module? (if .FALSE. this is done globally)
-    LOGICAL ::  aver_q   = .FALSE.  !< switch: do e  averaging in this module?
-    LOGICAL ::  aver_u   = .FALSE.  !< switch: do u  averaging in this module?
-    LOGICAL ::  aver_v   = .FALSE.  !< switch: do v  averaging in this module?
-    LOGICAL ::  aver_w   = .FALSE.  !< switch: do w  averaging in this module?
-    LOGICAL ::  average_trigger_pt   = .FALSE.  !< update averaged input on call to biom_pt?
-    LOGICAL ::  average_trigger_utci = .FALSE.  !< update averaged input on call to biom_utci?
-    LOGICAL ::  average_trigger_pet  = .FALSE.  !< update averaged input on call to biom_pet?
-
-    LOGICAL ::  mrt_from_rtm   = .TRUE.   !< switch: use mrt calculated by RTM for calculation of thermal indices
-    LOGICAL ::  biom_pt        = .TRUE.   !< Turn index PT (instant. input) on or off
-    LOGICAL ::  biom_pt_av     = .TRUE.   !< Turn index PT (averaged input) on or off
-    LOGICAL ::  biom_pet       = .TRUE.   !< Turn index PET (instant. input) on or off
-    LOGICAL ::  biom_pet_av    = .TRUE.   !< Turn index PET (averaged input) on or off
-    LOGICAL ::  biom_utci      = .TRUE.   !< Turn index UTCI (instant. input) on or off
-    LOGICAL ::  biom_utci_av   = .TRUE.   !< Turn index UTCI (averaged input) on or off
-
-!-- Add INTERFACES that must be available to other modules (alphabetical order)
-
-    PUBLIC biom_3d_data_averaging, biom_check_data_output,                     &
-    biom_calculate_static_grid, biom_calc_ipt,                                 &
-    biom_check_parameters, biom_data_output_3d, biom_data_output_2d,           &
-    biom_define_netcdf_grid, biom_determine_input_at, biom_header, biom_init,  &
-    biom_init_arrays, biom_parin, biom_pt, biom_pt_av, biom_pet, biom_pet_av,  &
-    biom_utci, biom_utci_av, time_biom_results
+    LOGICAL ::  aver_perct = .FALSE.  !< switch: do perct averaging in this module? (if .FALSE. this is done globally)
+    LOGICAL ::  aver_q     = .FALSE.  !< switch: do e  averaging in this module?
+    LOGICAL ::  aver_u     = .FALSE.  !< switch: do u  averaging in this module?
+    LOGICAL ::  aver_v     = .FALSE.  !< switch: do v  averaging in this module?
+    LOGICAL ::  aver_w     = .FALSE.  !< switch: do w  averaging in this module?
+    LOGICAL ::  aver_mrt   = .FALSE.  !< switch: do mrt averaging in this module?
+    LOGICAL ::  average_trigger_perct = .FALSE.  !< update averaged input on call to bio_perct?
+    LOGICAL ::  average_trigger_utci  = .FALSE.  !< update averaged input on call to bio_utci?
+    LOGICAL ::  average_trigger_pet   = .FALSE.  !< update averaged input on call to bio_pet?
+
+    LOGICAL ::  bio_perct     = .TRUE.   !< Turn index PT (instant. input) on or off
+    LOGICAL ::  bio_perct_av  = .TRUE.   !< Turn index PT (averaged input) on or off
+    LOGICAL ::  bio_pet       = .TRUE.   !< Turn index PET (instant. input) on or off
+    LOGICAL ::  bio_pet_av    = .TRUE.   !< Turn index PET (averaged input) on or off
+    LOGICAL ::  bio_utci      = .TRUE.   !< Turn index UTCI (instant. input) on or off
+    LOGICAL ::  bio_utci_av   = .TRUE.   !< Turn index UTCI (averaged input) on or off
+
+
+!
+!-- INTERFACES that must be available to other modules (alphabetical order)
+
+    PUBLIC bio_3d_data_averaging, bio_check_data_output,                       &
+    bio_calculate_mrt_grid, bio_calculate_thermal_index_maps, bio_calc_ipt,    &
+    bio_check_parameters, bio_data_output_3d, bio_data_output_2d,              &
+    bio_define_netcdf_grid, bio_get_thermal_index_input_ij, bio_header,        &
+    bio_init, bio_init_arrays, bio_parin, bio_perct, bio_perct_av, bio_pet,    &
+    bio_pet_av, bio_utci, bio_utci_av, time_bio_results
 
 !
@@ -160,72 +157,77 @@
 !
 !-- 3D averaging for HTCM _INPUT_ variables
-    INTERFACE biom_3d_data_averaging
-       MODULE PROCEDURE biom_3d_data_averaging
-    END INTERFACE biom_3d_data_averaging
+    INTERFACE bio_3d_data_averaging
+       MODULE PROCEDURE bio_3d_data_averaging
+    END INTERFACE bio_3d_data_averaging
+
+!-- Calculate mtr from rtm fluxes and assign into 2D grid
+    INTERFACE bio_calculate_mrt_grid
+       MODULE PROCEDURE bio_calculate_mrt_grid
+    END INTERFACE bio_calculate_mrt_grid
 
 !-- Calculate static thermal indices PT, UTCI and/or PET
-    INTERFACE biom_calculate_static_grid
-       MODULE PROCEDURE biom_calculate_static_grid
-    END INTERFACE biom_calculate_static_grid
+    INTERFACE bio_calculate_thermal_index_maps
+       MODULE PROCEDURE bio_calculate_thermal_index_maps
+    END INTERFACE bio_calculate_thermal_index_maps
 
 !-- Calculate the dynamic index iPT (to be caled by the agent model)
-    INTERFACE biom_calc_ipt
-       MODULE PROCEDURE biom_calc_ipt
-    END INTERFACE biom_calc_ipt
+    INTERFACE bio_calc_ipt
+       MODULE PROCEDURE bio_calc_ipt
+    END INTERFACE bio_calc_ipt
 
 !-- Data output checks for 2D/3D data to be done in check_parameters
-     INTERFACE biom_check_data_output
-        MODULE PROCEDURE biom_check_data_output
-     END INTERFACE biom_check_data_output
+     INTERFACE bio_check_data_output
+        MODULE PROCEDURE bio_check_data_output
+     END INTERFACE bio_check_data_output
 
 !-- Input parameter checks to be done in check_parameters
-    INTERFACE biom_check_parameters
-       MODULE PROCEDURE biom_check_parameters
-    END INTERFACE biom_check_parameters
+    INTERFACE bio_check_parameters
+       MODULE PROCEDURE bio_check_parameters
+    END INTERFACE bio_check_parameters
 
 !-- Data output of 2D quantities
-    INTERFACE biom_data_output_2d
-       MODULE PROCEDURE biom_data_output_2d
-    END INTERFACE biom_data_output_2d
+    INTERFACE bio_data_output_2d
+       MODULE PROCEDURE bio_data_output_2d
+    END INTERFACE bio_data_output_2d
 
 !-- no 3D data, thus, no averaging of 3D data, removed
-    INTERFACE biom_data_output_3d
-       MODULE PROCEDURE biom_data_output_3d
-    END INTERFACE biom_data_output_3d
+    INTERFACE bio_data_output_3d
+       MODULE PROCEDURE bio_data_output_3d
+    END INTERFACE bio_data_output_3d
 
 !-- Definition of data output quantities
-    INTERFACE biom_define_netcdf_grid
-       MODULE PROCEDURE biom_define_netcdf_grid
-    END INTERFACE biom_define_netcdf_grid
+    INTERFACE bio_define_netcdf_grid
+       MODULE PROCEDURE bio_define_netcdf_grid
+    END INTERFACE bio_define_netcdf_grid
 
 !-- Obtains all relevant input values to estimate local thermal comfort/stress
-    INTERFACE biom_determine_input_at
-       MODULE PROCEDURE biom_determine_input_at
-    END INTERFACE biom_determine_input_at
+    INTERFACE bio_get_thermal_index_input_ij
+       MODULE PROCEDURE bio_get_thermal_index_input_ij
+    END INTERFACE bio_get_thermal_index_input_ij
 
 !-- Output of information to the header file
-    INTERFACE biom_header
-       MODULE PROCEDURE biom_header
-    END INTERFACE biom_header
+    INTERFACE bio_header
+       MODULE PROCEDURE bio_header
+    END INTERFACE bio_header
 
 !-- Initialization actions 
-    INTERFACE biom_init
-       MODULE PROCEDURE biom_init
-    END INTERFACE biom_init
+    INTERFACE bio_init
+       MODULE PROCEDURE bio_init
+    END INTERFACE bio_init
 
 !-- Initialization of arrays
-    INTERFACE biom_init_arrays
-       MODULE PROCEDURE biom_init_arrays
-    END INTERFACE biom_init_arrays
+    INTERFACE bio_init_arrays
+       MODULE PROCEDURE bio_init_arrays
+    END INTERFACE bio_init_arrays
 
 !-- Reading of NAMELIST parameters
-    INTERFACE biom_parin
-       MODULE PROCEDURE biom_parin
-    END INTERFACE biom_parin
-
- 
+    INTERFACE bio_parin
+       MODULE PROCEDURE bio_parin
+    END INTERFACE bio_parin
+
+
  CONTAINS
- 
- 
+
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -234,14 +236,14 @@
 !> the array necessary for storing the average.
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_3d_data_averaging( mode, variable )
+ SUBROUTINE bio_3d_data_averaging( mode, variable )
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  mode     !< 
-    CHARACTER (LEN=*) ::  variable !< 
-
-    INTEGER(iwp) ::  i  !< 
-    INTEGER(iwp) ::  j  !< 
-    INTEGER(iwp) ::  k  !< 
+    CHARACTER (LEN=*) ::  mode     !< averaging mode: allocate, sum, or average
+    CHARACTER (LEN=*) ::  variable !< The variable in question
+
+    INTEGER(iwp) ::  i        !< Running index, x-dir
+    INTEGER(iwp) ::  j        !< Running index, y-dir
+    INTEGER(iwp) ::  k        !< Running index, z-dir
 
 
@@ -250,23 +252,23 @@
        SELECT CASE ( TRIM( variable ) )
 
-          CASE ( 'biom_mrt' )
-                IF ( .NOT. ALLOCATED( biom_mrt_av ) )  THEN
-                   ALLOCATE( biom_mrt_av(nmrtbl) )
+          CASE ( 'bio_mrt' )
+                IF ( .NOT. ALLOCATED( mrt_av_grid ) )  THEN
+                   ALLOCATE( mrt_av_grid(nmrtbl) )
                 ENDIF
-                biom_mrt_av = 0.0_wp
-
-          CASE ( 'biom_pt', 'biom_utci', 'biom_pet' )
+                mrt_av_grid = 0.0_wp
+
+          CASE ( 'bio_perct*', 'bio_utci*', 'bio_pet*' )
 
 !--          Indices in unknown order as depending on input file, determine 
 !            first index to average und update only once
-             IF ( .NOT. average_trigger_pt .AND. .NOT. average_trigger_utci    &
+             IF ( .NOT. average_trigger_perct .AND. .NOT. average_trigger_utci &
                 .AND. .NOT. average_trigger_pet ) THEN
-                IF ( TRIM( variable ) == 'biom_pt' ) THEN
-                    average_trigger_pt = .TRUE.
+                IF ( TRIM( variable ) == 'bio_perct*' ) THEN
+                    average_trigger_perct = .TRUE.
                 ENDIF
-                IF ( TRIM( variable ) == 'biom_utci' ) THEN
+                IF ( TRIM( variable ) == 'bio_utci*' ) THEN
                     average_trigger_utci = .TRUE.
                 ENDIF
-                IF ( TRIM( variable ) == 'biom_pet' ) THEN
+                IF ( TRIM( variable ) == 'bio_pet*' ) THEN
                     average_trigger_pet = .TRUE.
                 ENDIF
@@ -274,12 +276,12 @@
 
 !--          Only continue if updateindex
-             IF ( average_trigger_pt   .AND. TRIM( variable ) /= 'biom_pt')   RETURN
-             IF ( average_trigger_utci .AND. TRIM( variable ) /= 'biom_utci') RETURN
-             IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'biom_pet')  RETURN
+             IF ( average_trigger_perct .AND. TRIM( variable ) /= 'bio_perct*') RETURN
+             IF ( average_trigger_utci .AND. TRIM( variable ) /= 'bio_utci*')   RETURN
+             IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'bio_pet*')    RETURN
 
 !--          Set averaging switch to .TRUE. if not done by other module before!
              IF ( .NOT. ALLOCATED( pt_av ) )  THEN
                 ALLOCATE( pt_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
-                aver_pt = .TRUE.
+                aver_perct = .TRUE.
              ENDIF
              pt_av = 0.0_wp
@@ -292,5 +294,5 @@
 
              IF ( .NOT. ALLOCATED( u_av ) )  THEN
-                ALLOCATE( u_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
+                ALLOCATE( u_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
                 aver_u = .TRUE.
              ENDIF
@@ -298,5 +300,5 @@
 
              IF ( .NOT. ALLOCATED( v_av ) )  THEN
-                ALLOCATE( v_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
+                ALLOCATE( v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
                 aver_v = .TRUE.
              ENDIF
@@ -304,5 +306,5 @@
 
              IF ( .NOT. ALLOCATED( w_av ) )  THEN
-                ALLOCATE( w_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
+                ALLOCATE( w_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
                 aver_w = .TRUE.
              ENDIF
@@ -318,31 +320,29 @@
        SELECT CASE ( TRIM( variable ) )
 
-          CASE ( 'biom_mrt' )
-             IF ( ALLOCATED( biom_mrt_av ) )  THEN
-
-                 IF ( nmrtbl > 0 )  THEN
-                    IF ( mrt_include_sw )  THEN
-                       biom_mrt_av(:) = biom_mrt_av(:) + &
-                          ((human_absorb*mrtinsw(:) + human_emiss*mrtinlw(:))  &
-                          / (human_emiss*sigma_sb)) ** .25_wp - degc_to_k
-                    ELSE
-                       biom_mrt_av(:) = biom_mrt_av(:) + &
-                          (human_emiss * mrtinlw(:) / sigma_sb) ** .25_wp      &
-                          - degc_to_k
-                    ENDIF
-                 ENDIF
+          CASE ( 'bio_mrt' )
+             IF ( ALLOCATED( mrt_av_grid ) )  THEN
+
+                IF ( mrt_include_sw )  THEN
+                   mrt_av_grid(:) = mrt_av_grid(:) +                           &
+                      (( human_absorb * mrtinsw(:) + human_emiss * mrtinlw(:)) &
+                      / (human_emiss * sigma_sb)) ** .25_wp - degc_to_k
+                ELSE
+                   mrt_av_grid(:) = mrt_av_grid(:) +                           &
+                      (human_emiss * mrtinlw(:) / sigma_sb) ** .25_wp          &
+                      - degc_to_k
+                ENDIF
              ENDIF
 
-          CASE ( 'biom_pt', 'biom_utci', 'biom_pet' )
+          CASE ( 'bio_perct*', 'bio_utci*', 'bio_pet*' )
 
 !--          Only continue if updateindex
-             IF ( average_trigger_pt   .AND. TRIM( variable ) /= 'biom_pt')    &
+             IF ( average_trigger_perct .AND. TRIM( variable ) /= 'bio_perct*') &
                 RETURN
-             IF ( average_trigger_utci .AND. TRIM( variable ) /= 'biom_utci')  &
+             IF ( average_trigger_utci .AND. TRIM( variable ) /= 'bio_utci*')  &
                 RETURN
-             IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'biom_pet')   &
+             IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'bio_pet*')   &
                 RETURN
 
-             IF ( ALLOCATED( pt_av ) .AND. aver_pt ) THEN
+             IF ( ALLOCATED( pt_av ) .AND. aver_perct ) THEN
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
@@ -365,6 +365,6 @@
 
              IF ( ALLOCATED( u_av )  .AND. aver_u ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
+                DO  i = nxlg, nxrg       !< yes, ghost points are required here!
+                   DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
                          u_av(k,j,i) = u_av(k,j,i) + u(k,j,i)
@@ -375,6 +375,6 @@
 
              IF ( ALLOCATED( v_av )  .AND. aver_v ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
+                DO  i = nxlg, nxrg       !< yes, ghost points are required here!
+                   DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
                          v_av(k,j,i) = v_av(k,j,i) + v(k,j,i)
@@ -385,6 +385,6 @@
 
              IF ( ALLOCATED( w_av )  .AND. aver_w ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
+                DO  i = nxlg, nxrg       !< yes, ghost points are required here!
+                   DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
                          w_av(k,j,i) = w_av(k,j,i) + w(k,j,i)
@@ -403,20 +403,20 @@
        SELECT CASE ( TRIM( variable ) )
 
-          CASE ( 'biom_mrt' )
-             IF ( ALLOCATED( biom_mrt_av ) )  THEN
-                biom_mrt_av(:) = biom_mrt_av(:) / REAL( average_count_3d, KIND=wp )
+          CASE ( 'bio_mrt' )
+             IF ( ALLOCATED( mrt_av_grid ) )  THEN
+                mrt_av_grid(:) = mrt_av_grid(:) / REAL( average_count_3d, KIND=wp )
              ENDIF
 
-          CASE ( 'biom_pt', 'biom_utci', 'biom_pet' )
+          CASE ( 'bio_perct*', 'bio_utci*', 'bio_pet*' )
 
 !--          Only continue if update index
-             IF ( average_trigger_pt   .AND. TRIM( variable ) /= 'biom_pt')    &
+             IF ( average_trigger_perct .AND. TRIM( variable ) /= 'bio_perct*') &
                 RETURN
-             IF ( average_trigger_utci .AND. TRIM( variable ) /= 'biom_utci')  &
+             IF ( average_trigger_utci .AND. TRIM( variable ) /= 'bio_utci*')  &
                 RETURN
-             IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'biom_pet')   &
+             IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'bio_pet*')   &
                 RETURN
 
-             IF ( ALLOCATED( pt_av ) .AND. aver_pt ) THEN
+             IF ( ALLOCATED( pt_av ) .AND. aver_perct ) THEN
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
@@ -439,6 +439,6 @@
 
              IF ( ALLOCATED( u_av ) .AND. aver_u ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
+                DO  i = nxlg, nxrg       !< yes, ghost points are required here!
+                   DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
                          u_av(k,j,i) = u_av(k,j,i) / REAL( average_count_3d, KIND=wp )
@@ -449,6 +449,6 @@
 
              IF ( ALLOCATED( v_av ) .AND. aver_v ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
                          v_av(k,j,i) = v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
@@ -459,6 +459,6 @@
 
              IF ( ALLOCATED( w_av ) .AND. aver_w ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
                          w_av(k,j,i) = w_av(k,j,i) / REAL( average_count_3d, KIND=wp )
@@ -469,5 +469,5 @@
 
 !--          Udate thermal indices with derived averages
-             CALL biom_calculate_static_grid ( .TRUE. )
+             CALL bio_calculate_thermal_index_maps ( .TRUE. )
 
         END SELECT
@@ -476,5 +476,5 @@
 
 
- END SUBROUTINE biom_3d_data_averaging
+ END SUBROUTINE bio_3d_data_averaging
 
 
@@ -485,5 +485,5 @@
 !> Check data output for biometeorology model
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_check_data_output( var, unit )
+ SUBROUTINE bio_check_data_output( var, unit )
 
     USE control_parameters,                                                    &
@@ -498,5 +498,5 @@
     SELECT CASE ( TRIM( var ) )
      
-       CASE( 'biom_tmrt', 'biom_mrt', 'biom_pet', 'biom_pt', 'biom_utci' )
+       CASE( 'bio_mrt', 'bio_pet*', 'bio_perct*', 'bio_utci*' )
           unit = 'degree_C'
 
@@ -509,19 +509,21 @@
 !
 !--    Futher checks if output belongs to biometeorology
-       IF ( .NOT. biometeorology .OR. .NOT. radiation ) THEN
-         message_string = 'output of "' // TRIM( var ) // '" req' //  &
-               'uires biometeorology = .TRUE. and radiation = .TRUE. ' &
-               // 'in initialisation_parameters'
-         CALL message( 'biom_check_data_output', 'PA0561', 1, 2, 0, 6, 0 )
+       IF ( .NOT.  radiation ) THEN
+          message_string = 'output of "' // TRIM( var ) // '" require'         &
+                           // 's radiation = .TRUE.'
+          CALL message( 'check_parameters', 'PA0509', 1, 2, 0, 6, 0 )
+          unit = 'illegal'
        ENDIF
        IF ( mrt_nlevels == 0 ) THEN
-          message_string = 'output of "' // TRIM( var ) // '" require'&
+          message_string = 'output of "' // TRIM( var ) // '" require'         &
                            // 's mrt_nlevels > 0'
-          CALL message( 'biom_check_data_output', 'PA0562', 1, 2, 0, 6, 0 )
+          CALL message( 'check_parameters', 'PA0510', 1, 2, 0, 6, 0 )
+          unit = 'illegal'
        ENDIF
 
-    ENDIF
-
- END SUBROUTINE biom_check_data_output
+
+    ENDIF
+
+ END SUBROUTINE bio_check_data_output
 
 !------------------------------------------------------------------------------!
@@ -531,5 +533,5 @@
 !> check_parameters 1302
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_check_parameters
+ SUBROUTINE bio_check_parameters
 
     USE control_parameters,                                                    &
@@ -541,143 +543,14 @@
 
 !--    Disabled as long as radiation model not available
-       IF ( .NOT. radiation )  THEN
-          message_string = 'The human thermal comfort module does require ' // &
-                           'radiation information in terms of the mean ' //    &
-                           'radiant temperature, but radiation is not enabled!'
-          CALL message( 'check_parameters', 'PAHU01', 0, 0, 0, 6, 0 )
-       ENDIF
 
        IF ( .NOT. humidity )  THEN
-          message_string = 'The human thermal comfort module does require ' // &
+          message_string = 'The estimation of thermal comfort requires '    // &
                            'air humidity information, but humidity module ' // &
                            'is disabled!'
-          CALL message( 'check_parameters', 'PAHU02', 0, 0, 0, 6, 0 )
+          CALL message( 'check_parameters', 'PA0561', 0, 0, 0, 6, 0 )
        ENDIF
 
- END SUBROUTINE biom_check_parameters
-
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Subroutine defining 3D output variables (dummy, always 2d!)
-!> data_output_3d 709ff
-!------------------------------------------------------------------------------!
- SUBROUTINE biom_data_output_3d( av, variable, found, local_pf, nzb_do, nzt_do )
-
-    USE indices
-
-    USE kinds
-
-
-    IMPLICIT NONE
-
-!-- Input variables
-    CHARACTER (LEN=*), INTENT(IN) ::  variable   !< Char identifier to select var for output
-    INTEGER(iwp), INTENT(IN) ::  av       !< Use averaged data? 0 = no, 1 = yes?
-    INTEGER(iwp), INTENT(IN) ::  nzb_do   !< Unused. 2D. nz bottom to nz top
-    INTEGER(iwp), INTENT(IN) ::  nzt_do   !< Unused.
-
-!-- Output variables
-    LOGICAL, INTENT(OUT) ::  found   !< Output found?
-    REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf   !< Temp. result grid to return
-
-!-- Internal variables
-    INTEGER(iwp) ::  l    !< Running index, radiation grid
-    INTEGER(iwp) ::  i    !< Running index, x-dir
-    INTEGER(iwp) ::  j    !< Running index, y-dir
-    INTEGER(iwp) ::  k    !< Running index, z-dir
-
-    CHARACTER (LEN=:), allocatable ::  variable_short  !< Trimmed version of char variable
-
-    REAL(wp), PARAMETER ::  fill_value = -999._wp
-    REAL(wp) ::  mrt  !< Buffer for mean radiant temperature
-
-    found = .TRUE.
-    variable_short = TRIM( variable )
-
-    IF ( variable_short(1:4) /= 'biom' ) THEN
-!--   Nothing to do, set found to FALSE and return immediatelly
-      found = .FALSE.
-      RETURN
-    ENDIF
-
-    SELECT CASE ( variable_short )
-
-        CASE ( 'biom_mrt' )
-
-            local_pf = REAL( fill_value, KIND = wp )
-            DO  l = 1, nmrtbl
-                i = mrtbl(ix,l)
-                j = mrtbl(iy,l)
-                k = mrtbl(iz,l)
-                IF ( mrt_include_sw )  THEN
-                    mrt = ((human_absorb*mrtinsw(l) + human_emiss*mrtinlw(l)) &
-                           / (human_emiss*sigma_sb)) ** .25_wp
-                ELSE
-                    mrt = (human_emiss*mrtinlw(l) / sigma_sb) ** .25_wp
-                ENDIF
-                local_pf(i,j,k) = mrt
-            ENDDO
-
-        CASE ( 'biom_tmrt' )        ! 2d-array
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb_do) = REAL( tmrt_grid(j,i), sp )
-                 ENDDO
-              ENDDO
-
-        CASE ( 'biom_pt' )        ! 2d-array
-            IF ( av == 0 )  THEN
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb_do) = REAL( pt_grid(j,i), sp )
-                 ENDDO
-              ENDDO
-            ELSE
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb_do) = REAL( pt_av_grid(j,i), sp )
-                 ENDDO
-              ENDDO
-            END IF
-
-        CASE ( 'biom_utci' )        ! 2d-array
-            IF ( av == 0 )  THEN
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb_do) = REAL( utci_grid(j,i), sp )
-                 ENDDO
-              ENDDO
-            ELSE
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb_do) = REAL( utci_av_grid(j,i), sp )
-                 ENDDO
-              ENDDO
-            END IF
-
-        CASE ( 'biom_pet' )        ! 2d-array
-            IF ( av == 0 )  THEN
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb_do) = REAL( pet_grid(j,i), sp )
-                 ENDDO
-              ENDDO
-            ELSE
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,nzb_do) = REAL( pet_av_grid(j,i), sp )
-                 ENDDO
-              ENDDO
-            END IF
-
-       CASE DEFAULT
-          found = .FALSE.
-
-    END SELECT
-
- END SUBROUTINE biom_data_output_3d
+ END SUBROUTINE bio_check_parameters
+
 
 !------------------------------------------------------------------------------!
@@ -688,5 +561,5 @@
 !> data_output_2d 1188ff
 !------------------------------------------------------------------------------!
- SUBROUTINE biom_data_output_2d( av, variable, found, grid, local_pf,          &
+ SUBROUTINE bio_data_output_2d( av, variable, found, grid, local_pf,           &
                                       two_d, nzb_do, nzt_do, fill_value )
 
@@ -717,17 +590,14 @@
     INTEGER(iwp) ::  j        !< Running index, y-dir
     INTEGER(iwp) ::  k        !< Running index, z-dir
-
-
-    found = .TRUE.
+    INTEGER(iwp) ::  l        !< Running index, radiation grid
+
+
     variable_short = TRIM( variable )
-    IF ( variable_short(1:4) == 'biom' ) THEN
-       two_d = .TRUE.
-       grid = 'zu1'
-    ELSE
+    IF ( variable_short(1:4) /= 'bio_' ) THEN
        found = .FALSE.
        grid  = 'none'
-       RETURN
-    ENDIF
-
+    ENDIF
+
+    found = .TRUE.
     local_pf = fill_value
 
@@ -735,17 +605,36 @@
 
 
-        CASE ( 'biom_tmrt_xy' )        ! 2d-array
-              DO  i = nxl, nxr
-                 DO  j = nys, nyn
-                    local_pf(i,j,1) = tmrt_grid(j,i)
-                 ENDDO
-              ENDDO
-
-
-        CASE ( 'biom_pt_xy' )        ! 2d-array
+        CASE ( 'bio_mrt_xy' )
+            grid = 'zu1'
+            two_d = .FALSE.  !< can be calculated for several levels
+            local_pf = REAL( fill_value, KIND = wp )
+            DO  l = 1, nmrtbl
+               i = mrtbl(ix,l)
+               j = mrtbl(iy,l)
+               k = mrtbl(iz,l)
+               IF ( k < nzb_do .OR. k > nzt_do .OR. j < nys .OR. j > nyn .OR.  &
+                  i < nxl .OR. i > nxr ) CYCLE
+               IF ( av == 0 )  THEN
+                  IF ( mrt_include_sw )  THEN
+                     local_pf(i,j,k) = ((human_absorb * mrtinsw(l) +           &
+                     human_emiss * mrtinlw(l)) /                               &
+                     (human_emiss * sigma_sb)) ** .25_wp - degc_to_k
+                  ELSE
+                     local_pf(i,j,k) = (human_emiss * mrtinlw(l) /             &
+                                        sigma_sb) ** .25_wp - degc_to_k
+                  ENDIF
+               ELSE
+                  local_pf(i,j,k) = mrt_av_grid(l)
+               ENDIF
+            ENDDO
+
+
+        CASE ( 'bio_perct*_xy' )        ! 2d-array
+            grid = 'zu1'
+            two_d = .TRUE.
             IF ( av == 0 )  THEN
               DO  i = nxl, nxr
                  DO  j = nys, nyn
-                    local_pf(i,j,nzb+1) = pt_grid(j,i)
+                    local_pf(i,j,nzb+1) = perct(j,i)
                  ENDDO
               ENDDO
@@ -753,5 +642,5 @@
               DO  i = nxl, nxr
                  DO  j = nys, nyn
-                    local_pf(i,j,nzb+1) = pt_av_grid(j,i)
+                    local_pf(i,j,nzb+1) = perct_av(j,i)
                  ENDDO
               ENDDO
@@ -759,5 +648,7 @@
 
 
-        CASE ( 'biom_utci_xy' )        ! 2d-array
+        CASE ( 'bio_utci*_xy' )        ! 2d-array
+            grid = 'zu1'
+            two_d = .TRUE.
             IF ( av == 0 )  THEN
               DO  i = nxl, nxr
